#pragma region License
/*
License (OLC-3)
~~~~~~~~~~~~~~~

Copyright 2018 - 2023 OneLoneCoder.com

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions or derivations of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions or derivative works in binary form must reproduce the above
copyright notice. This list of conditions and the following	disclaimer must be
reproduced in the documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may
be used to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS	"AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT	HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL,	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
#pragma endregion
#include <string>
#include <vector>
#include <memory>
#include "safemap.h"
#include <set>

class VisualNovel;

namespace CommandType{
	enum CommandType{
		PAUSE,
		DIALOG,
		SPEAKER,
		BACKGROUND,
		RIGHT,
		LEFT,
		LOCATION
	};
}

class Command{
	friend class VisualNovel;
	virtual void Execute(VisualNovel&vn)=0;
protected:
	Command();
public:
	virtual CommandType::CommandType GetType()=0;
};

class PauseCommand final:public Command{
public:
	void Execute(VisualNovel&vn)override;
	PauseCommand();
	CommandType::CommandType GetType()final override;
};

class DialogCommand final:public Command{
	std::string dialog;
public:
	void Execute(VisualNovel&vn)override;
	DialogCommand(std::string dialog);
	CommandType::CommandType GetType()final override;
};

class SpeakerCommand final:public Command{
	std::string displayedName;
	std::string actualSpeakerName;
public:
	void Execute(VisualNovel&vn)override;
	SpeakerCommand(std::string speaker);
	SpeakerCommand(std::string displayedName,std::string speaker);
	CommandType::CommandType GetType()final override;
};

class BackgroundCommand final:public Command{
	std::string backgroundFilename;
public:
	void Execute(VisualNovel&vn)override;
	BackgroundCommand(std::string backgroundFilename);
	CommandType::CommandType GetType()final override;
};

class RightCommand final:public Command{
	std::vector<std::string>characters;
public:
	void Execute(VisualNovel&vn)override;
	RightCommand(std::vector<std::string>characters);
	CommandType::CommandType GetType()final override;
};

class LeftCommand final:public Command{
	std::vector<std::string>characters;
public:
	void Execute(VisualNovel&vn)override;
	LeftCommand(std::vector<std::string>characters);
	CommandType::CommandType GetType()final override;
};

class LocationCommand final:public Command{
	std::string location;
public:
	void Execute(VisualNovel&vn)override;
	LocationCommand(std::string location);
	CommandType::CommandType GetType()final override;
};

class VisualNovel{
	friend class State_Story;
	friend class Crawler;
	friend class Command;
	friend class LocationCommand;
	friend class BackgroundCommand;
	friend class LeftCommand;
	friend class RightCommand;
	friend class SpeakerCommand;
	friend class DialogCommand;
	friend class PauseCommand;
	std::string storyLevel;
	std::string speakerDisplayName="";
	std::string	actualSpeakerName="";
	std::string activeText;
	std::vector<std::string>leftCharacters;
	std::vector<std::string>rightCharacters;
	std::string backgroundFilename;
	std::string prevBackgroundFilename;
	float transitionTime=0;
	static constexpr float maxTransitionTime=2.0f;
	std::vector<Command*>commands;
	int commandIndex=0;
	std::string locationDisplayText="";
	float locationDisplayTime=0;
	std::string prevTheme="";
	float textScrollTime=0;
	static constexpr float maxTextScrollTime=1.0f;

	static std::set<std::string>graphicsToLoad;
	static safemap<std::string,std::vector<std::unique_ptr<Command>>>storyLevelData;

	static VisualNovel novel;
	VisualNovel();
public:
	VisualNovel(VisualNovel&)=delete;
	VisualNovel(VisualNovel&&)=delete;
	static void Initialize();
	static void LoadVisualNovel(std::string storyLevelName);
	void ExecuteNextCommand();
	void Update();
	void Draw();
	std::string GetCharacterImage(std::string name);
};